(* This file was originally generated by why.
   It can be modified; only the generated parts will be overwritten. *)

Require Export Caduceus.
Require Export WhyFloats.

(*Why type*) Definition global: Set.
Admitted.


(*Why logic*) Definition my_killing_prop : double -> double -> Z -> Prop.
exact (fun (uc up:double) (N:Z) => 
   (exists eps: nat -> R,
     (forall i:nat, i<= N -> (Rabs (eps i) <= powerRZ radix (-53))%R) /\
     (d_to_r up-d_to_exact up = sum_f_R0 
        (fun i:nat => (N-i)*(eps i))
         (minus (Zabs_nat N) 1))%R /\ 
     (d_to_r uc-d_to_exact uc = sum_f_R0 
        (fun i:nat => (N+1-i)*(eps i))
         (Zabs_nat N))%R)). 
Defined.



Lemma Le2errLe: forall (r:R), forall (f:float),
   (EvenClosest bdouble radix 53 r f) -> (Rabs r <= 15/8)%R 
      -> (Rabs (r-f) <= powerRZ radix (-53))%R.
intros.
apply Rmult_le_reg_l with (INR 2); auto with real zarith.
apply Rle_trans with (Fulp bdouble radix 53 f).
unfold FtoRradix; apply ClosestUlp; auto with zarith.
elim H; trivial.
replace (INR 2) with (powerRZ radix 1);
  [rewrite <- powerRZ_add; auto with real zarith| simpl; ring].
unfold Fulp; apply Rle_powerRZ.
simpl; auto with real.
apply Zle_trans with (Fexp (Float (15*Zpower_nat radix 49) (-52)));
   [idtac|simpl; auto with zarith].
apply Fcanonic_Rle_Zle with radix bdouble 53%nat; auto with zarith.
apply FnormalizeCanonic; auto with zarith.
elim H; intros (N1,N2) N3; auto.
left; split; try split.
rewrite pdGivesBound; apply Zle_lt_trans with (15 * Zpower_nat radix 49)%Z; auto with zarith.
simpl; auto with zarith.
rewrite pdGivesBound; apply Zle_trans with (2*(15 * Zpower_nat radix 49))%Z; 
   auto with zarith.
rewrite FnormalizeCorrect; auto with zarith.
rewrite <- Fabs_correct with radix (Float (15 * Zpower_nat radix 49) (-52));auto with zarith.
apply RoundAbsMonotoner with bdouble 53%nat (EvenClosest bdouble radix 53) r; 
   auto with zarith.
apply absFBounded; auto; split.
rewrite pdGivesBound; apply Zle_lt_trans with (15 * Zpower_nat radix 49)%Z; auto with zarith.
simpl; auto with zarith.
apply Rle_trans with (1:=H0).
right; unfold FtoR, Fabs.
apply trans_eq with (Zabs (15 * Zpower_nat radix 49)* powerRZ radix (-52))%R; auto.
rewrite Zabs_eq; auto with zarith.
rewrite mult_IZR; rewrite Zpower_nat_Z_powerRZ; rewrite Rmult_assoc.
rewrite <- powerRZ_add; auto with real zarith.
replace (S 48 +-52)%Z with (-3)%Z;simpl; [field|ring].
replace (2*1)%R with 2%R; auto with real.
assert (0 < 8*8)%R; auto with real.
assert (0 < 8)%R.
apply Rlt_le_trans with 2%R; auto with real.
apply Rle_trans with 4%R; auto with real.
apply Rle_lt_trans with (0*8)%R;[right; ring|apply Rmult_lt_compat_r; auto with real].
Qed.



Lemma my_killing_prop_rnd_error: forall (uc up: double), forall N:Z,
    (0 <= N)%Z ->
    (my_killing_prop uc up N) ->
    ((double_round_error uc) <= (N+1)*(N+2)*/2*powerRZ radix (-53))%R.
unfold my_killing_prop; intros  uc up N T (eps, (H1,(H2,H3))).
unfold double_round_error.
replace (d_to_exact uc - d_to_r uc)%R with (-(d_to_r uc - d_to_exact uc))%R;[idtac|ring].
rewrite Rabs_Ropp; rewrite H3.
apply Rle_trans with (1:=Rsum_abs  (fun i : nat => ((N + 1 - i) * eps i)%R)
  (Zabs_nat N)).
assert (Y:(N =Z_of_nat (Zabs_nat N))); auto with zarith.
rewrite <- Zabs_absolu; rewrite Zabs_eq; auto with zarith.
apply Rle_trans with  (sum_f_R0 (fun l : nat => 
   (Rabs ((N + 1 - l) * powerRZ radix (-53)))) (Zabs_nat N)).
apply sum_Rle.
intros n H; repeat rewrite Rabs_mult.
apply Rmult_le_compat_l; auto with real.
rewrite (Rabs_right (powerRZ radix (-53))); try apply Rle_ge; auto with real zarith.
apply Rle_trans with  (sum_f_R0 (fun l : nat => 
   (((N + 1 - l) * powerRZ radix (-53))%R)) (Zabs_nat N)).
apply sum_Rle.
intros n H.
repeat rewrite Rabs_right; auto with real.
apply Rle_ge; apply Rmult_le_pos; auto with real zarith.
assert (0 <= N+1-n)%Z; auto with real zarith.
apply Rle_trans with (IZR (N+1-n)); auto with real zarith.
unfold Zminus, Rminus; right; repeat rewrite plus_IZR; rewrite Ropp_Ropp_IZR.
simpl;  rewrite <- INR_IZR_INZ; auto.
cut (forall n:nat, forall A:R,
  (sum_f_R0 (fun l : nat => (n + 1 - l) * A) n =
    (n + 1) * (n + 2) * / 2 * A)%R).
intros P; right; pattern N at 1 3 4; rewrite Y.
repeat rewrite <- INR_IZR_INZ;apply P.
clear H1 H2 H3 Y.
induction n; intros A.
apply trans_eq with A;[simpl; ring|field; auto with real].
rewrite tech5.
replace ((S n + 1 - S n) * A)%R with A;[idtac|ring].
rewrite Rplus_comm.
apply trans_eq with  (A+sum_f_R0 (fun l : nat => 
   ((n + 1 - l) * A+ A)%R) n)%R.
apply Rplus_eq_compat_l.
apply sum_eq; intros.
replace (INR (S n)) with (n+1)%R;[ring|auto with real zarith].
simpl; case n; auto with real zarith.
apply trans_eq with  (A+(sum_f_R0 (fun l : nat => ((n + 1 - l) * A)) n
   +sum_f_R0 (fun l : nat =>  A) n))%R.
apply Rplus_eq_compat_l.
rewrite <- sum_plus; auto with real.
rewrite IHn.
rewrite sum_cte.
replace (INR (S n)) with (n+1)%R;[field;auto with real zarith|idtac].
simpl; case n; auto with real zarith.
Qed.


Lemma my_killing_prop_rnd_error2: forall (uc up: double), forall N:Z,
    (0 <= N)%Z ->
    (my_killing_prop uc up N) ->
    ((double_round_error up) <= N*(N+1)*/2*powerRZ radix (-53))%R.
unfold my_killing_prop; intros  uc up N T (eps, (H1,(H2,H3))).
unfold double_round_error.
replace (d_to_exact up - d_to_r up)%R with (-(d_to_r up - d_to_exact up))%R;[idtac|ring].
rewrite Rabs_Ropp; rewrite H2.
apply Rle_trans with (1:=Rsum_abs  (fun i : nat => ((N - i) * eps i)%R)
  (Zabs_nat N-1)).
assert (Y:(N =Z_of_nat (Zabs_nat N))); auto with zarith.
rewrite <- Zabs_absolu; rewrite Zabs_eq; auto with zarith.
apply Rle_trans with  (sum_f_R0 (fun l : nat => 
   (Rabs ((N  - l) * powerRZ radix (-53)))) (Zabs_nat N-1)).
apply sum_Rle.
intros n H; repeat rewrite Rabs_mult.
apply Rmult_le_compat_l; auto with real.
rewrite (Rabs_right (powerRZ radix (-53))); try apply Rle_ge; auto with real zarith.
apply Rle_trans with  (sum_f_R0 (fun l : nat => 
   (((N - l) * powerRZ radix (-53))%R)) (Zabs_nat N-1)).
apply sum_Rle.
intros n H.
repeat rewrite Rabs_right; auto with real.
apply Rle_ge; apply Rmult_le_pos; auto with real zarith.
assert (0 <= N-n)%Z; auto with real zarith.
apply Rle_trans with (IZR (N-n)); auto with real zarith.
unfold Zminus, Rminus; right; repeat rewrite plus_IZR; rewrite Ropp_Ropp_IZR.
simpl;  rewrite <- INR_IZR_INZ; auto.
cut (forall n:nat, forall A:R,
  (sum_f_R0 (fun l : nat => (n  - l) * A) (n-1) =
    n * (n + 1) * / 2 * A)%R).
intros P; right; pattern N at 1 3 4; rewrite Y.
repeat rewrite <- INR_IZR_INZ;apply P.
clear H1 H2 H3 Y.
induction n; intros A.
simpl; ring.
clear IHn; induction n.
simpl; field; auto with real.
replace  (S (S n) - 1)%nat with (S (S n -1)); auto with zarith.
rewrite tech5.
replace ((S (S n)  - S (S n-1)) * A)%R with A.
rewrite Rplus_comm.
apply trans_eq with  (A+sum_f_R0 (fun l : nat => 
   ((S n - l) * A+ A)%R) n)%R.
apply Rplus_eq_compat_l.
replace  (S n - 1)%nat with n; auto with zarith.
apply sum_eq; intros.
replace (INR (S (S n))) with (S n+1)%R;[ring|auto with real zarith].
apply trans_eq with  (A+(sum_f_R0 (fun l : nat => ((S n - l) * A)) n
   +sum_f_R0 (fun l : nat =>  A) n))%R.
apply Rplus_eq_compat_l.
rewrite <- sum_plus; auto with real.
pattern n at 2; replace  n with (S n - 1)%nat; auto with zarith.
rewrite IHn.
rewrite sum_cte.
replace (INR (S (S n))) with (S n+1)%R;[field;auto with real zarith|idtac].
apply trans_eq with (INR (S n +1)); auto with real zarith.
rewrite plus_INR; simpl; auto with real.
replace (INR (S (S n - 1))) with (S (S n) -1)%R; auto with real; [ring|idtac].
apply trans_eq with (INR ((S n -1)+1)); auto with zarith real.
apply trans_eq with (INR ((S n +1)-1)); auto with zarith real.
replace (S (S n)) with (S n+1)%nat; auto with real zarith.
rewrite minus_INR; auto with real zarith.
Qed.
